﻿var jhelper = {
	initTooltip : function(target) {
		$("[rel='tooltip']", target).tooltip( {
			trigger : "hover"
		});
	},
	initChosen : function(target) {
		$("select[ajaxchosen!='true']", target).each(function() {
			jhelper.setChosen(this);
		});
	},
	setChosen : function(ddl) {
		var $ddl = $(ddl);
		var issingle = ($ddl.attr("allow_single_deselect") == "true" ? true : false);
		var isdisablesearch = ($ddl.attr("disable_search") == "true" ? true : false);
		$ddl.chosen( {
			allow_single_deselect : issingle,
			disable_search : isdisablesearch,
			inherit_select_classes : true
		});
	},
	dateFormat : "MMM dd,yyyy",
	formatDate : function(dateTypeValue, format) {
		if (format == undefined) {
			format = "";
		}
		if (format == "") {
			format = jhelper.dateFormat;
		}
		return dateTypeValue.format(format);
	},
	initDatePicker : function(target) {
		$("input[date-picker='true']", target).each(function() {
			$(this).datepicker( {
				format : jhelper.dateFormat
			});
		});
		/*
		 * $("input[date-picker='true']",target) .each(function() { var
		 * $this=$(this); $this.datepicker({ changeMonth: true,changeYear: true
		 * ,onSelect: function(that) { var dt=new Date(that);
		 * $this.val(jhelper.formatDate(dt)); } }); });
		 */
	},
	parseFloat : function(v) {
		var rv = parseFloat(v);
		if (isNaN(rv)) {
			rv = 0;
		}
		return rv;
	},/*
	initPlaceHolder : function(target) {
		if (!$.browser.msie) {
			return true;
		}
		if ($.browser.version > 9) {
			return true;
			;
		}
		$('input[placeholder], textarea[placeholder]', target).placeholder();
	},*/
	currencySymbol : function() {
		return jhelper.currencySymbols[jhelper.currency];
	},

	addSeconds: function(time, seconds){
		return new Date("1991/01/01 " + time).addSeconds(seconds);
	},

	getTimeDiffObj: function(startTime, endTime) {
		var startDate	= new Date("1991/01/01 " + startTime);
		var endDate		= new Date("1991/01/01 " + endTime);

		return jhelper.get_time_difference(startDate, endDate);
	},

	getTimeDiffPercent : function(startTime, endTime) {
		if (startTime == "" || startTime == undefined || endTime == "" || endTime == undefined)
		{
			return 0;
		}

		var d = jhelper.getTimeDiffObj(startTime, endTime);
		d.minutes = ((Number("0." + d.minutes) / 60) * 100);
		return parseFloat(Number(d.hours) + Number(d.minutes)).toFixed(2);
	},

	getTimeDifference : function(startTime, endTime, format) {
		var d	= 	jhelper.getTimeDiffObj(startTime, endTime);
		var calc	= parseFloat(d.hours + "." + d.minutes);

		if (calc > 0)
		{
			if (d.hours == 0)
			{
				return parseFloat("0." + d.minutes);
			}
			else
			{
				var newd = new Date("01/01/1991 " + d.hours + ":" + d.minutes + ":" + d.seconds);
				var v = newd.format(format || "HH.NN");

				return parseFloat(v);
			}
		}
		return 0;
	},
	getTimeDiff: function(earlierDate, laterDate){
		var one_day	= 1000*60*60*24;
		earlierDate	= earlierDate ? new Date(earlierDate).getTime() : new Date().getTime();
		laterDate	= laterDate ? new Date(laterDate).getTime() : new Date().getTime();

		var oDiff	= {};
		var diff	= laterDate - earlierDate;
		oDiff.totalDiff	= diff;

		diff	= diff/1000;
		oDiff.seconds	= Math.floor(diff%60);
		oDiff.seconds	= oDiff.seconds>10 ? oDiff.seconds : "0"+oDiff.seconds;
		diff	= diff/60;
		oDiff.minutes	= Math.floor(diff%60);
		oDiff.minutes	= oDiff.minutes>10 ? oDiff.minutes : "0"+oDiff.minutes;
		diff	= diff/60;
		oDiff.hours	= Math.floor(diff%24);
		oDiff.hours	= oDiff.hours>10 ? oDiff.hours : "0"+oDiff.hours;
		diff	= diff/24;
		oDiff.days	= diff;
		oDiff.days	= oDiff.days>10 ? oDiff.days : "0"+oDiff.days;

		return oDiff;
	},
	get_time_difference: function(earlierDate, laterDate){
		var oDiff	= {};

		oDiff.totalDiff	= (laterDate.getTime() - earlierDate.getTime());
// console.log(oDiff.totalDiff);
		// (1000 * 60 * 60 * 24)	= 86400000	= 864E5
		oDiff.days	= Math.floor(oDiff.totalDiff/864E5) || 0;
		oDiff.days	= (oDiff.days < 10) ? "0" + oDiff.days : oDiff.days;
		oDiff.totalDiff	-= oDiff.days * 864E5;

		// (1000 * 60 * 60)	= 3600000	= 36E5
		oDiff.hours	= Math.floor(oDiff.totalDiff/36E5) || 0;
		oDiff.hours	= (oDiff.hours < 10) ? "0" + oDiff.hours : oDiff.hours;
		oDiff.totalDiff	-= oDiff.hours * 36E5;

		// (1000 * 60)	= 60000	= 6E4
		oDiff.minutes	= Math.floor(oDiff.totalDiff/6E4) || 0;
		oDiff.minutes	= (oDiff.minutes < 10) ? "0" + oDiff.minutes : oDiff.minutes;
		oDiff.totalDiff		-= oDiff.minutes * 6E4;

		// 1000	= 1E3
		oDiff.seconds	= Math.floor(oDiff.totalDiff/1E3) || 0;
		oDiff.seconds	= (oDiff.seconds < 10) ? "0" + oDiff.seconds : oDiff.seconds;
		oDiff.totalDiff		-= oDiff.seconds * 1E3;

		return oDiff;
	}
};

String.prototype.toAsciiTotal	= function(){
	var asciiTotal	= 0;
	for (var i=0, len=this.length; i<len; i++)
	{
		asciiTotal += this.charCodeAt(i);
	}
	return asciiTotal;
};
/*
String.prototype.shuffle1	= function(){
	var newStr	= [];
	var str	= this.split('');
	while (str.length)
	{
		newStr.push(str.splice(Math.floor(Math.random() * (str.length - 1)) , 1)[0]);
	}

	return newStr.join ('');
};
*/
String.prototype.shuffle	= function(){
	var parts	= this.split('');
	var random, temp;
	for (var i = parts.length; i>0;)
	{
		random	= parseInt(Math.random() * i);
		temp	= parts[--i];
		parts[i]	= parts[random];
		parts[random]	= temp;
	}
	return parts.join('');
};

(function(a){a.btoa||(a._Utf8Encode=function(b){if(!b)return!1;b=b.toString().replace(/\r\n/g,"\n");for(var c="",a=0;a<b.length;a++){var d=b.charCodeAt(a);128>d?c+=String.fromCharCode(d):(127<d&&2048>d?c+=String.fromCharCode(d>>6|192):(c+=String.fromCharCode(d>>12|224),c+=String.fromCharCode(d>>6&63|128)),c+=String.fromCharCode(d&63|128))}return c},a.keyStr="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",a.Base64_Encode=function(b){if(!b)return!1;b=b.toString();var c="",e,d,f,
l,k,g,h=0;for(b=a._Utf8Encode(b);h<b.length;)e=b.charCodeAt(h++),d=b.charCodeAt(h++),f=b.charCodeAt(h++),l=e>>2,e=(e&3)<<4|d>>4,k=(d&15)<<2|f>>6,g=f&63,isNaN(d)?k=g=64:isNaN(f)&&(g=64),c=c+a.keyStr.charAt(l)+a.keyStr.charAt(e)+a.keyStr.charAt(k)+a.keyStr.charAt(g);return c},a.btoa=a.btoa||a.Base64_Encode)})(window);

function getSVG(settings){
	settings.width	= settings.width || '100%';
	settings.height	= settings.height || '100%';

	var svg = $('<svg></svg>').attr({
		'xmlns': 'http://www.w3.org/2000/svg',
		'pointer-events':'none',
		'width': settings.width,
		'height': settings.height
	}).css({
		'background-color': settings.color || "transparent", //"#1abc9c",
		'width': settings.width,//+'px',
		'height': settings.height//+'px'
	});

	var cobj = $('<text text-anchor="middle"></text>').attr({
		'y': '50%',
		'x': '50%',
		'dy' : '0.35em',
		'pointer-events':'auto',
		'fill': settings.textColor || "#FFFFFF",
		'font-family': settings.fontFamily || 'Helvetica, Arial, sans-serif'
	}).html(settings.charTxt || "?").css({
		'font-weight': settings.fontWeight || 400,
		'font-size': settings.fontsize || '20px'
	});

	svg.append(cobj);

	var svgHtml = 'data:image/svg+xml;base64,' + window.btoa(unescape(encodeURIComponent($('<div>').append(svg.clone()).html())));

	return svgHtml;
};

function onImageError(elem)
{
	elem	= $(elem);
	var altText	= (elem.attr("title") || "?").trim() || "?";
	var className	= "";
	var metroClassesAll	= (typeof Otime!="undefined")?Otime.metroClassesAll:["bg-marine", "bg-pink", "bg-purple", "bg-orange", "bg-red", "bg-green", "bg-blue", "bg-fb", "bg-blue-light", "bg-green-light", "bg-violet"];
	if (!elem.is(".metro img"))
	{
		className	= Math.floor(altText.toAsciiTotal() % metroClassesAll.length);
//		className	= Math.floor(Math.random() * (Otime.metroClassesAll.length));
		className	= " " + metroClassesAll[className];
	}

	altText	= altText.substr(0,1).toUpperCase();
	elem.removeClass(metroClassesAll.join(" ") + " noImg").addClass("noImg" + className).attr("src", getSVG({
		charTxt: altText,
		fontsize: elem.attr("fnt-size"),
		width: elem.width(),
		height: elem.height()
	}));

	return true;
}

String.prototype.ucfirst	= function(only){
	if (only)
	{
		return (this.charAt(0).toUpperCase() + this.toLowerCase().slice(1));
	}
	return (this.charAt(0).toUpperCase() + this.slice(1));
};

Array.prototype.setKeys	= function(keys, clbk, keyAs, keyPref) {
	var ret = keyAs?{}:[];

	$.each(this, function(key, val) {
		var obj	= {};
		$.each(val, function(k, v){
			obj[keys[k]] = v;
		});
		if (typeof clbk == "function")
			clbk(obj, key);
		if (keyAs)
		{
			ret[(keyPref || "")+obj[keyAs]] = obj;
		}
		else
			ret.push(obj);
	});
	return ret;
};

Array.prototype.mergeSort	= function(comparator){
	var i, j, k, firstHalf, secondHalf, arr1, arr2;
	comparator	= comparator || function(a,b){return a<b?-1:1;};

	if (this.length > 1)
	{
		firstHalf = Math.floor(this.length / 2);
		secondHalf = this.length - firstHalf;
		arr1 = [];
		arr2 = [];

		for (i = 0; i < firstHalf; i++)
		{
			arr1[i] = this[i];
		}

		for(i = firstHalf; i < firstHalf + secondHalf; i++)
		{
			arr2[i - firstHalf] = this[i];
		}

		arr1.mergeSort( comparator );
		arr2.mergeSort( comparator );

		i=j=k=0;

		while(arr1.length != j && arr2.length != k)
		{
			if (comparator( arr1[j], arr2[k] ) < 0)
			{
				this[i] = arr1[j];
				i++;
				j++;
			}
			else
			{
				this[i] = arr2[k];
				i++;
				k++;
			}
		}

		while (arr1.length != j)
		{
			this[i] = arr1[j];
			i++;
			j++;
		}

		while (arr2.length != k)
		{
			this[i] = arr2[k];
			i++;
			k++;
		}
	}
	return this;
};
Object.values	= function (obj) {
	return (obj != undefined) ? Object.keys(obj).map(function (key) { return obj[key]; }) : [];
};

Object.keys = Object.keys || function(o) {
	var result	= [];
	for(var name in o)
	{
		if (o.hasOwnProperty(name))
		{
			result.push(name);
		}
	}
	return result; 
};

String.prototype.hashCode	= function(){
	var hash	= this.split("").reduce(function(a,b){a=((a<<5)-a)+b.charCodeAt(0);return a&a},0);
	return "HASH"+(hash.toString(36) + hash.toString(26) + hash.toString(16)).replace(/\-/g, "").toUpperCase();
}
function is_expired(response)
{
	if (response && response[0] == 3)
	{
		alert(response[1]);
		window.location.href = response[2].redirect || response[2];
		return true;
	}
	return false;
}
$(function() {

	$.fn.hasScrollBar	= function() {
		return this.get(0).scrollHeight > this.height();
	};

//	jhelper.initPlaceHolder($("body"));

	$("input,select").live("focus", function() {
		$(this).removeClass("error");
	});

	if (typeof Otime=="undefined") {
		return true;
	}
	// Ajax Global settings
	/*
	 * $.ajaxSetup({ data: {_t:getToken()}, });
	 */
	$(document).ajaxStart(function(event){
		$("body").addClass("loading");
		Otime.Message	= "";
		$("#alert_message .alert").remove();
	}).ajaxStop(function(){
		if (Otime.Message)
		{
			$("#alert_message").html(Otime.Message);
			Otime.Message	= "";
		}
		$("body").removeClass("loading not");
	}).ajaxSend(function(event, jqXHR, ajaxOptions){
		var ts	= Math.floor(event.timeStamp / 1000);
		jqXHR.setRequestHeader("time", ts);
		jqXHR.setRequestHeader("_t", getToken(ts));
//		jqXHR.setRequestHeader("Cache-Control", 'no-cache');
	}).ajaxError(function(event, request, settings) {
		if (request.status == 500 && window.location.href != Otime.siteUrl) {
			// $("#alert_message").html(request.statusText+' occured will redirect to home page with in 2 seconds!');
			setTimeout(function(){
				$("#alert_message .alert").remove();
				var llu = localStorage.getItem('ot_last_login')-0;
				if (llu) {
					var llu = 'ot_'+llu;
					localStorage.setItem(llu, '');
				}
				
				/*window.location.href = Otime.siteUrl;*/
			}, 2000);

		}
	});
//	$.ajax({beforeSend: function(xhr){
//		console.log("Called 2 : ", xhr);
//	}});
	/*
	 * $(document).ajaxComplete(function(response, t){
	 * console.log(t.responseText); });
	 */
});

// Ajax validation token generator Begins
function randomString(length)
{
	var chars = "PLM7OKN4I5JB6UHV9YGC8TFX2RD1ZE3SA0WQ";
	// var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	var ret = "";
	for ( var i = 0; i < length; i++)
	{
		var rnum = Math.floor(Math.random() * chars.length);
		chr = chars.substring(rnum, rnum + 1);
		ret += chr;
		chars	= chars.replace(chr, "");
	}
	// String.fromCharCode(72,101,108,108,111,32,87,111,114,108,100,33)
	return ret;
}

function getToken(ts)
{
	var rs = ret = randomString(12);
	ts = ts+"";
	for ( var i = 0; i < ts.length; i++)
	{
		ret += rs[parseInt(ts[i])];
	}
	return ret;
}
// Ajax validation token generator End
// DNA Encryption method
function DNA(str)
{
	var plain_text	= str || "MESUK";
	var start_num	= 100;
	var modulo		= 25;

	var substitution_array	= [start_num];
	var ascii_array	= [];
	var quotient	= [];
	var remind		= [];

	for (var i=0,len=plain_text.length; i<len; i++)
	{
	    ascii_array[i]	= plain_text.charCodeAt(i);
	    substitution_array[i+1]	= substitution_array[i] + modulo;
	    quotient[i]	= Math.floor(substitution_array[i]/ascii_array[i]);
	    remind[i]	= substitution_array[i]%ascii_array[i]
	}
	substitution_array = substitution_array.slice(0,-1);
	var total_array	= (quotient.join() + "," + remind.join()).split(",");
	var convert_array	= [];
	var hyphen_index	= [];
	var tmp	= "";
	var dna_map	= ["A", "T", "C", "G"];
	var ret = "";
	var hypen = 0;
	for (var i=0, len=total_array.length;i<len;i++)
	{
		tmp	= (total_array[i]-0).toString(4)-0;
		convert_array[i]	= tmp;
		tmp	= tmp + "";
		for (var j=0,l=tmp.length;j<l;j++)
		{
			ret += dna_map[tmp[j]];
			hypen++;
		}
		hypen++;
		hyphen_index.push(hypen);
	}
	
//	console.log(ascii_array, quotient, remind, substitution_array, total_array, convert_array);
//	console.log(total_array, convert_array);
	console.log("Input : ", str);
	console.log("output : ", ret, hyphen_index);
	return ret;
}
function toRadix(N,radix,chars)
{
	if (isNaN(N))
	{
		return false;
	}
	chars	= chars || "0123456789abcdefghijklmnopqrstuvwxyz";
	radix	= radix || (chars ? chars.length : 10);
	var HexN	= "",
		R	= "",
		Q		= Math.floor(Math.abs(N));
	while (true)
	{
		R	= Q % radix;
		HexN = chars.charAt(R) + HexN;
		Q	= (Q-R)/radix; 
		if (Q==0)
		{
			break;
		}
	}
	return ((N<0) ? "-" + HexN : HexN);
}
