(function(Otime){

	var colgroups	= "";
	var thead_tr	= "";
	var tbody_tr	= "";
	var tbody_tmpl	= "";

	var taskCols	= {
		ttype:function(){
			colgroups	+= '<col for="ttype" style="width:180px;">';

			thead_tr	+= '<th class="pr">';
			thead_tr	+= '	<span class="dib fw pr cp" data-bind="click:sort(\'task_type_name\')">Task Type</span>';
			thead_tr	+= '	<span class="column_filter" data-bind="click:filter_column(\'task_type\')">';
			thead_tr	+= '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.task_type_id}"></i>';
			thead_tr	+= '	</span>';
			thead_tr	+= '</th>';

			tbody_tr	+= '<td class="ttype" target="ttype">';
			tbody_tr	+= '	<span class="ttype" data-bind="visible:(form.name()&&!form.is_parent()), text:form.task_type_name"></span>';
			tbody_tr	+= '</td>';
		},
		duration:function(){
			colgroups	+= '<col for="duration" style="width:70px;">';

			thead_tr	+= '<th class="pr ac">';
			thead_tr	+= '	<span class="dib fw pr cp" data-bind="click:sort(\'duration\')">Duration</span>';
			thead_tr	+= '</th>';

			tbody_tr	+= '<td class="duration" target="duration">';
			tbody_tr	+= '	<span class="duration" data-bind="visible:form.name, vtext:form.duration"></span>';
			tbody_tr	+= '</td>';
		},
		sdate:function(){
			colgroups	+= '<col for="sdate" style="width:90px;">';

			thead_tr	+= '<th class="pr ac">';
			thead_tr	+= '	<span class="dib fw pr cp" data-bind="click:sort(\'start_date\')">Start Date</span>';
			thead_tr	+= '</th>';

			tbody_tr	+= '<td class="sdate" target="sdate" data-bind="date:{date:form.start_date, fi:form.name().length>0||form.task_id()>0}">';
			tbody_tr	+= '</td>';
		},
		fdate:function(){
			colgroups	+= '<col for="fdate" style="width:90px;">';

			thead_tr	+= '<th class="pr ac">';
			thead_tr	+= '	<span class="dib fw pr cp" data-bind="click:sort(\'finish_date\')">Finish Date</span>';
			thead_tr	+= '</th>';

			tbody_tr	+= '<td class="fdate" target="fdate" data-bind="date:{date:form.finish_date, fi:form.name().length>0||form.task_id()>0}">';
			tbody_tr	+= '</td>';
		},
		esthrs:function(){
			colgroups	+= '<col for="esthrs" style="width:70px;">';

			thead_tr	+= '<th class="pr ac">';
			thead_tr	+= '	<span class="dib fw pr cp" data-bind="click:sort(\'estimated_hours\')">Estimated Hours</span>';
			thead_tr	+= '</th>';

			tbody_tr	+= '<td class="esthrs" target="esthrs" data-bind="text:form.estimated_hours">';
			tbody_tr	+= '</td>';
		},
		acthrs:function(){
			colgroups	+= '<col for="acthrs" style="width:70px;">';

			thead_tr	+= '<th class="pr ac">';
			thead_tr	+= '	<span class="dib fw pr cp" data-bind="click:sort(\'worked_hours\')">Actual Hours</span>';
			thead_tr	+= '</th>';

			tbody_tr	+= '<td class="acthrs" target="acthrs" data-bind="hours:{val:form.worked_hours}">';
			tbody_tr	+= '</td>';
		},
		status:function(){
			colgroups	+= '<col for="status" style="width:77px;">';

			thead_tr	+= '<th class="pr">';
			thead_tr	+= '	<span class="dib fw pr cp" data-bind="click:sort(\'status\')">Status</span>';
			thead_tr	+= '	<span class="column_filter" data-bind="click:filter_column(\'task_status\')">';
			thead_tr	+= '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.task_status_id()>0}"></i>';
			thead_tr	+= '	</span>';
			thead_tr	+= '</th>';

			tbody_tr	+= '<td class="status" target="status" data-bind="with:status">';
			tbody_tr	+= '	<span class="label status" data-bind="text:name, hidden:$parent.form.is_parent, style:{backgroundColor:bg_color, color:text_color}"></span>';
			tbody_tr	+= '</td>';
		},
		assignee:function(){
			colgroups	+= '<col for="assignee" style="width:85px;">';

			thead_tr	+= '<th class="pr">';
			thead_tr	+= '	<span class="dib fw pr">Assignee</span>';
			thead_tr	+= '	<span class="column_filter" data-bind="click:filter_column(\'assignee_id\')">';
			thead_tr	+= '		<i class="icon icon-filter" data-bind="css:{\'active\':$root.task_assignee_id}"></i>';
			thead_tr	+= '	</span>';
			thead_tr	+= '</th>';

			tbody_tr	+= '<td class="assignee" target="assignee">';
			tbody_tr	+= '	<span class="assignee" data-bind="visible:(form.name() && !form.is_parent()), text:form._info.assignee_disp"></span>';
			tbody_tr	+= '</td>';
		},
		followers:function(){
			colgroups	+= '<col for="followers" style="width:150px;">';

			thead_tr	+= '<th class="pr">';
			thead_tr	+= '	<span class="dib fw pr">Followers</span>';
			thead_tr	+= '</th>';

			tbody_tr	+= '<td class="followers" target="followers">';
			tbody_tr	+= '	<span class="assignee" data-bind="visible:(form.name() && !form.is_parent()), text:form._info.followers_disp"></span>';
			tbody_tr	+= '</td>';
		},
		predec:function(){
			colgroups	+= '<col for="predec" style="width:100px;">';

			thead_tr	+= '<th class="pr ac">';
			thead_tr	+= '	<span class="dib fw pr">Predecessors</span>';
			thead_tr	+= '</th>';

			tbody_tr	+= '<td class="predec" target="predec" data-bind="text:form.predecessors">';
			tbody_tr	+= '</td>';
		}
	};

	Otime.getTaskTmpl	= function(parent_elem){
		colgroups	= "";
		thead_tr	= "";
		tbody_tr	= "";
		tbody_tmpl	= '<script type="text/html" id="mainTmpl2">';

		var columns	= Otime.Storage.get("tasks_columns");
		if (!columns)
		{
			columns	= "ttype,duration,sdate,fdate,esthrs,status,assignee,followers,acthrs";
			Otime.Storage.set("tasks_columns", columns);
		}
		var selectedCols	= columns.split(",");

		tbody_tmpl	+= '<!-- ko if:is_visible -->';
		tbody_tmpl	+= '<tr class="" data-bind="cls:\'task_\'+uniqueId()+\' num_\'+form.task_number(), css:{\'ne\':!is_editable(), \'over-due\':is_over_due, \'closed\':is_closed}">';

		for (var i=0,iLen=selectedCols.length; i<iLen; i++)
		{
			taskCols[selectedCols[i]]();
		}

		tbody_tmpl	+= tbody_tr;
		tbody_tmpl	+= '</tr>';
		tbody_tmpl	+= '<!-- ko template:{name:\'mainTmpl2\', foreach:children, if:show_child} --><!-- /ko -->';
		tbody_tmpl	+= '<!-- /ko -->';
		tbody_tmpl	+= '</script>';

		parent_elem.append(tbody_tmpl);
		$("#box2-head table colgroup", parent_elem).html(colgroups);
		$("#box2-body #task-table2 colgroup", parent_elem).html(colgroups);
		$("#box2-head table thead tr", parent_elem).html(thead_tr);
	};
}(window.Otime));
